/***************************************/
// Nastaven pikompilovvanch modul: /
/***************************************/

// Buto se pikompiluj vechny moduly:
# define INCLUDE_MODULE_ALL 1

// Nebo pouze nsledujc vybran:
# define INCLUDE_MODULE_DAMY 1
# define INCLUDE_MODULE_STANICE 1
# define INCLUDE_MODULE_TSP 1
# define INCLUDE_MODULE_CESTA 1

// Poznmka .1: Moduly se vyazuj z innosti zakomentovnm (tzn. pidnm
// dvou lomtek na zatek dku, podobn jako je zakomentovn tento text).
// Poznmka .2: Zmny v zakomentovn dlch modul nemaj na program vliv,
// pokud nen souasn zakomentovn dek pro pikompilovn vech modul.
// Poznmka .3: Vdy mus bt v innosti alespo jeden modul.

/***************************************/

# ifdef INCLUDE_MODULE_ALL
# define INCLUDE_MODULE_DAMY 1
# define INCLUDE_MODULE_STANICE 1
# define INCLUDE_MODULE_TSP 1
# define INCLUDE_MODULE_CESTA 1
# endif

struct _ModulInfo {
  string KrtkJmno; // krtk jmno modulu - max. 8 znak, bez diakritiky
  string DlouhJmno; // dlouh jmno modulu - libovoln dlka, v. diakritiky
  string Popis; // strun popis innosti modulu
  double Verze; // slo verze modulu
  TypDatum Datum; // datum posledn aktualizace modulu
  string Autor; // jmno autora modulu
  string Kontakt; // kontaktn daje autora modulu
  // ukazatele na funkce:
  void (*Start)(void); // ped startem vpotu
  void (*Hotovo)(void); // po dokonen vpotu
  void (*klid)(void); // klid po innosti modulu
  void (*ZadnVstupu)(void); // zadn vstupnch dat vpotu
  void (*OptimalizaceVstupu)(void); // optimalizace vstupnch dat vpotu
  void (*OpakovnInicializace)(void); // inicializace opakovn lnk
  int (*OpakovnTest)(void); // test, zda pokraovat v opakovn lnk
  void (*OpakovnIterace)(void); // iterace pi opakovn lnk
  void (*Dal硬lnek_Ped)(void); // ped zapoetm vpotem dalho lnku
  void (*Dal硬lnek_Po)(void); // po dokonen vpotu dalho lnku
  int (*TestVyhovuje)(void); // test, zda aktuln een vyhovuje podmnkm
  int (*TestNalezeno)(void); // test, zda bylo nalezeno kompletn een
  void (*Nalezeno)(void); // pi nalezen kompletnho vyhovujcho een
  } ModulyInfo[0

# ifdef INCLUDE_MODULE_DAMY
+1
# endif

# ifdef INCLUDE_MODULE_STANICE
+1
# endif

# ifdef INCLUDE_MODULE_TSP
+1
# endif

# ifdef INCLUDE_MODULE_CESTA
+1
# endif

];

struct _ModulInfo* AktivnModul; // ukazazel na strukturu ModulInfo prv aktivnho modulu

# include "backtraq.mod\shared.inc"

# ifdef INCLUDE_MODULE_DAMY
# include "backtraq.mod\damy.inc"
# endif

# ifdef INCLUDE_MODULE_STANICE
# include "backtraq.mod\stanice.inc"
# endif

# ifdef INCLUDE_MODULE_TSP
# include "backtraq.mod\tsp.inc"
# endif

# ifdef INCLUDE_MODULE_CESTA
# include "backtraq.mod\cesta.inc"
# endif

void InfoOModulech(void) {
int modul_id=0;

# ifdef INCLUDE_MODULE_DAMY
modDamy_InfoOModulu(&ModulyInfo[modul_id++]);
# endif

# ifdef INCLUDE_MODULE_STANICE
modStanice_InfoOModulu(&ModulyInfo[modul_id++]);
# endif

# ifdef INCLUDE_MODULE_TSP
modTSP_InfoOModulu(&ModulyInfo[modul_id++]);
# endif

# ifdef INCLUDE_MODULE_CESTA
modCesta_InfoOModulu(&ModulyInfo[modul_id++]);
# endif

}